Index: branches/WebJobManager/HeuristicLab.Clients.Hive.WebJobManager/Hubs/CalendarHub.cs
===================================================================
--- branches/WebJobManager/HeuristicLab.Clients.Hive.WebJobManager/Hubs/CalendarHub.cs	(revision 13782)
+++ branches/WebJobManager/HeuristicLab.Clients.Hive.WebJobManager/Hubs/CalendarHub.cs	(revision 13795)
@@ -1,4 +1,5 @@
 ﻿using HeuristicLab.Clients.Access.Administration;
 using HeuristicLab.Clients.Hive.WebJobManager.Services;
+using HeuristicLab.Clients.Hive.WebJobManager.ViewModels.User;
 using Microsoft.AspNet.SignalR;
 using Newtonsoft.Json;
@@ -16,4 +17,6 @@
         private Guid userId;
         private HiveAdminClientWeb adminClient;
+        private HiveServiceLocatorWeb servloc;
+        private AccessAdministrationClient accessClient;
         private void loader()
         {
@@ -28,4 +31,6 @@
                 userId = Guid.Parse(uid);
                 adminClient = weblog.getAdminClient(userId);
+                servloc = weblog.getServiceLocator(userId);
+                accessClient = weblog.getAccessAdminClient(userId);
             }
         }
@@ -34,7 +39,9 @@
             loader();
             adminClient.Refresh();
-            
+            UserViewModel vm = new UserViewModel(accessClient).refreshAll();
+            var users = JsonConvert.SerializeObject(vm.users);
+            var groups = JsonConvert.SerializeObject(vm.ugroups);
             var res = JsonConvert.SerializeObject(adminClient.Resources);
-            Clients.Caller.processData(res);
+            Clients.Caller.processData(res, users, groups);
         }
         public void requestDownTime(string id)
@@ -47,4 +54,43 @@
             var down = JsonConvert.SerializeObject(adminClient.Downtimes);
             Clients.Caller.processDowntime(id, down);
+        }
+        public void requestPermissions(string id)
+        {
+            loader();
+            Guid r = Guid.Parse(id);
+            var perm = servloc.CallHiveService(x => x.GetResourcePermissions(r));
+            Clients.Caller.processPermissions(id, JsonConvert.SerializeObject(perm));
+        }
+
+        public void changePermissions(string[] perms, string idresource)
+        {
+            loader();
+            var res = Guid.Parse(idresource);
+            var exist = servloc.CallHiveService(x => x.GetResourcePermissions(res));
+            List<Guid> newPerms = new List<Guid>();
+            List<Guid> revokePerms = new List<Guid>();
+            for (var i = 0; i < perms.Length; i++)
+            {
+                var p = Guid.Parse(perms[i]);
+                var elemid = exist.FindIndex(x => x.GrantedUserId == p);
+                if (elemid != -1)
+                {
+                    exist[elemid].GrantedUserId = Guid.Empty;
+                }
+                else
+                {
+                    newPerms.Add(p);
+                }
+            }
+            servloc.CallHiveService(x => x.GrantResourcePermissions(res, newPerms));
+            foreach (var ex in exist)
+            {
+                if(ex.GrantedUserId != Guid.Empty)
+                {
+                    revokePerms.Add(ex.GrantedUserId);
+                }
+            }
+            servloc.CallHiveService(x => x.RevokeResourcePermissions(res, revokePerms));
+            requestPermissions(idresource);
         }
         public void toggleDisposable(string id)
Index: branches/WebJobManager/HeuristicLab.Clients.Hive.WebJobManager/Scripts/Hubs/CalendarHubber.js
===================================================================
--- branches/WebJobManager/HeuristicLab.Clients.Hive.WebJobManager/Scripts/Hubs/CalendarHubber.js	(revision 13782)
+++ branches/WebJobManager/HeuristicLab.Clients.Hive.WebJobManager/Scripts/Hubs/CalendarHubber.js	(revision 13795)
@@ -14,4 +14,5 @@
                vm.alertMessage = "No alerts";
                vm.currentcal = [];
+               $scope.permission = false;
                vm.selectedEventId = -1;
                vm.groups = [];
@@ -27,8 +28,10 @@
                        hubber.server.requestInfo();
                    });
-                   hubber.client.processData = function (data) {
+                   hubber.client.processData = function (data, users, groups) {
                        vm.data = JSON.parse(data);
+                       vm.permUsers = JSON.parse(users);
+                       vm.permGroups = JSON.parse(groups);
                        $scope.buildTree();
-
+                      
                        $scope.$apply();
                    };
@@ -48,4 +51,12 @@
                        $scope.$apply();
                    }
+                   hubber.client.processPermissions = function (id, perm) {
+                       var json = JSON.parse(perm);
+                      
+                       $scope.treeview.currentNode.permissions = json;
+                       refreshPermissions();
+                       $scope.permissionLoader = false;
+                       $scope.$apply();
+                   }
                    hubber.client.processDowntime = function (id, down) {
                        var json = JSON.parse(down);
@@ -91,13 +102,15 @@
                        $(".selected.ng-binding").addClass('loaded');
                        $scope.selectedEventId = -1;
+                       
                        if ($scope.treeview.currentNode != null && $scope.treeview.currentNode.Id != undefined) {
                            if ($scope.treeview.currentNode.calendar.length === 0) {
+                               hubber.server.requestPermissions(vm.treeview.currentNode.Id);
                                hubber.server.requestDownTime(vm.treeview.currentNode.Id);
-
+                               vm.permissionLoader = true;
                            }
                            else {
                                $timeout(function () {
+                                   refreshPermissions();
                                    $scope.currentcal = $scope.treeview.currentNode.calendar;
-
                                }, 0);
 
@@ -106,4 +119,20 @@
 
                    });
+               }
+               function refreshPermissions() {
+                   for (var i = 0; i < $scope.permUsers.length; i++){
+                       $scope.permUsers[i].state = false;
+                       for (var j = 0; j < $scope.treeview.currentNode.permissions.length; j++) {
+                           if($scope.permUsers[i].Id === $scope.treeview.currentNode.permissions[j].GrantedUserId)
+                               $scope.permUsers[i].state = true;
+                       }
+                   }
+                   for (var i = 0; i < $scope.permGroups.length; i++) {
+                       $scope.permGroups[i].state = false;
+                       for (var j = 0; j < $scope.treeview.currentNode.permissions.length; j++) {
+                           if ($scope.permGroups[i].Id === $scope.treeview.currentNode.permissions[j].GrantedUserId)
+                               $scope.permGroups[i].state = true;
+                       }
+                   }
                }
                $scope.clearTreeSelect = function () {
@@ -179,10 +208,22 @@
                    return current;
                }
-
                $scope.toggleDisposable = function () {
                    $scope.calendarDispose = true;
                    hubber.server.toggleDisposable(vm.treeview.currentNode.Id);
                }
-
+               $scope.pushPermissions = function () {
+                   var perms = [];
+                   $scope.permissionLoader = true;
+                   var node = $scope.treeview.currentNode;
+                   for (var i = 0; i < $scope.permGroups.length; i++) {
+                       if ($scope.permGroups[i].state === true)
+                           perms.push($scope.permGroups[i].Id);
+                   }
+                   for (var i = 0; i < $scope.permUsers.length; i++) {
+                       if ($scope.permUsers[i].state === true)
+                           perms.push($scope.permUsers[i].Id);
+                   }
+                   hubber.server.changePermissions(perms, node.Id);
+               }
                function collectInfoToSave(node, refresh, last) {
                    var arr = node.calendar.down[0];
@@ -273,4 +314,5 @@
                    $scope.currentcal = [];
                    hubber.server.requestDownTime(vm.treeview.currentNode.Id);
+                   $(".selected.ng-scope").removeClass('changed');
                    $(".selected.ng-binding").removeClass('changed');
 
@@ -293,5 +335,7 @@
                function clearAllCalendarsFunc() {
                    $(".ng-binding.changed").removeClass('changed');
+                   $(".ng-scope.changed").removeClass('changed');
                    $(".ng-binding.loaded").removeClass('loaded');
+                   $(".ng-scope.loaded").removeClass('loaded');
                    $scope.selectedEventId = -1;
                    $scope.treeview.currentNode.calendar = null;
@@ -301,4 +345,5 @@
                    hubber.server.requestDownTime(vm.treeview.currentNode.Id);
                    $(".selected.ng-binding").addClass('loaded');
+                   $(".selected.ng-scope").addClass('loaded');
                }
                function clearCalendarsRecurse(node) {
@@ -361,5 +406,5 @@
                    }
                    vm.treeview.currentNode.changes = true;
-                   $(".selected.ng-binding").addClass('changed');
+                   $(".selected").addClass('changed');
                }
                //*Add event by click
Index: branches/WebJobManager/HeuristicLab.Clients.Hive.WebJobManager/Views/Resource/Index.cshtml
===================================================================
--- branches/WebJobManager/HeuristicLab.Clients.Hive.WebJobManager/Views/Resource/Index.cshtml	(revision 13782)
+++ branches/WebJobManager/HeuristicLab.Clients.Hive.WebJobManager/Views/Resource/Index.cshtml	(revision 13795)
@@ -8,6 +8,19 @@
 
     <div class="col-sm-4">
-        <div class="btn btn-block btn-success" ng-click="clearTreeSelect()">Add group</div>
-        <div data-angular-treeview="true"
+        <div class="btn-group btn-group-justified" style="padding:3px;margin-bottom:-10px"
+             role="group">
+            <a class="btn btn-info btn-lg btn-block disabled"
+               style="width:6%; box-shadow: 0 4px 8px 0 rgba(0, 0, 0, 0.2), 0 6px 20px 0 rgba(0, 0, 0, 0.19);
+                            text-shadow:2px 2px black;">
+                <i class="fa fa-sitemap"></i> Resource groups
+            </a>
+            <div class="btn btn-block btn-success"
+                 style="box-shadow: 0 4px 8px 0 rgba(0, 0, 0, 0.2), 0 6px 20px 0 rgba(0, 0, 0, 0.19);
+                            text-shadow:2px 2px black;"
+                 ng-click="clearTreeSelect()"><i class="fa fa-plus-circle"></i></div>
+        </div>
+
+        <div style=""
+             data-angular-treeview="true"
              data-tree-id="treeview"
              data-tree-model="tree"
@@ -24,5 +37,5 @@
             <h3>
                 {{treeview.currentNode.Name}}
-                <span ng-if="treeview.currentNode.IsDisposable === undefined"> - Client group</span>
+                <span ng-if="treeview.currentNode.IsDisposable === undefined"> - Resource group</span>
                 <a ng-if="treeview.currentNode.IsDisposable !== undefined"
                    class="btn pull-right"
@@ -34,5 +47,56 @@
                 </a>
             </h3>
-            <form method="post"
+            <ul class="nav nav-pills nav-justified">
+                <li role="presentation" ng-class="{ 'active': !permission }" ng-style="{ 'text-decoration': !permission ? 'underline' : ''}">
+                    <a style="text-shadow:2px 2px black; color:white; font-weight:bold; border: 1px solid white;"
+                       href=""
+                       ng-click="permission = false">
+                        Resource info
+                    </a>
+                </li>
+                <li role="presentation" ng-class="{ 'active': permission }" ng-style="{ 'text-decoration': permission ? 'underline' : ''}">
+                    <a style="text-shadow:2px 2px black; color:white; font-weight:bold; border: 1px solid white;"
+                       href=""
+                       ng-click="permission = true">
+                        Permissions
+                    </a>
+                </li>
+            </ul>
+            
+            <form ng-show="permission"
+                  method="post"
+                  asp-action="editPermissions"
+                  asp-controller="Resource"
+                  enctype="multipart/form-data"
+                  class="row panel-heading"
+                  > 
+                <div
+                     class="row" style="padding:10px;">
+                    <h4>Groups</h4>
+                    <label class="col-sm-3" ng-repeat="group in permGroups">
+                        <input type="checkbox" 
+                               name="permgroups" 
+                               value="{{group.Id}}"
+                               ng-model="group.state"> {{group.Name}}
+                    </label>
+                </div>
+                <div class="row" style="padding:10px;">
+                    <h4>Users</h4>
+                    <label class="col-sm-3 col-lg-2" ng-repeat="user in permUsers">
+                        <input type="checkbox" 
+                               name="permusers" 
+                               value="{{user.Id}}"
+                               ng-model="user.state"> {{user.UserName}}
+                    </label>
+                </div>
+                <div class="btn btn-info pull-right" 
+                     style="box-shadow: 0 4px 8px 0 rgba(0, 0, 0, 0.2), 0 6px 20px 0 rgba(0, 0, 0, 0.19);
+                            text-shadow:2px 2px black;"
+                     ng-click="pushPermissions()">
+                <i ng-if="permissionLoader" class="fa fa-spin fa-save"></i> 
+                Save permission changes</div>
+            </form>
+            <form ng-show="!permission"
+                  method="post"
                   asp-action="deleteClientGroup"
                   ng-init="checkDel = false"
@@ -40,5 +104,5 @@
                   enctype="multipart/form-data"
                   class="row panel-heading"
-                  style="padding:10px">
+                  style="padding:10px;">
                 <table class="table" style="margin-bottom:0px">
                     <tbody>
@@ -71,5 +135,7 @@
                                         id="inpsaver"
                                         ng-disabled="!checkDel"
-                                        class="btn btn-danger">
+                                        class="btn btn-danger"
+                                        style="box-shadow: 0 4px 8px 0 rgba(0, 0, 0, 0.2), 0 6px 20px 0 rgba(0, 0, 0, 0.19);
+                            text-shadow:2px 2px black;">
                                     <i class="fa fa-trash-o"></i>
                                     Delete group (irriversible action!)
@@ -100,17 +166,16 @@
                   enctype="multipart/form-data"
                   class="row"
-                  style="padding:10px"
-                  >
+                  style="padding:10px;">
                 <input style="display:none" type="text" id="inpid" name="inpid" value="{{treeview.currentNode.Id}}" />
 
                 <span style="padding:0px" class="col-sm-4">Change parent resource: </span>
-                
-                <select class="form-control col-sm-5" 
-                        style="width:200px" 
-                        id="inpidpar" 
-                        name="inpidpar" 
+
+                <select class="form-control col-sm-5"
+                        style="width:200px"
+                        id="inpidpar"
+                        name="inpidpar"
                         ng-model="treeview.currentNode.ParentResourceId">
                     <option value="">None</option>
-                    <option ng-repeat="group in groups | orderBy:'Name'" 
+                    <option ng-repeat="group in groups | orderBy:'Name'"
                             value="{{group.Id}}"
                             ng-if="group.Id !=treeview.currentNode.Id && group.ParentResourceId != treeview.currentNode.Id">
@@ -121,5 +186,7 @@
                 <button type="submit"
                         id="inpsaver"
-                        class="btn btn-warning col-sm-3 pull-right">
+                        class="btn btn-warning col-sm-3 pull-right"
+                        style="box-shadow: 0 4px 8px 0 rgba(0, 0, 0, 0.2), 0 6px 20px 0 rgba(0, 0, 0, 0.19);
+                            text-shadow:2px 2px black;">
                     <i class="fa fa-save"></i>
                     Change parent
@@ -326,5 +393,6 @@
         <div class="row panel-footer">
             <h2>All events </h2><h5>(sorted by changed and start date)</h5>
-            <div class="row" ng-repeat="ev in currentcal.down[0] | orderBy:['!changed','start'] track by $index">
+            <div class="row" ng-repeat="ev in currentcal.down[0] | orderBy:['!changed','start'] track by $index"
+                 style="margin-bottom:4px">
                 <div class="btn-group-justified btn-block">
 
@@ -370,10 +438,10 @@
               asp-controller="Resource"
               enctype="multipart/form-data"
-              class="col-sm-8 panel  panel-primary">
+              class="col-sm-8 panel panel-primary">
             <div class="row panel-heading"
                  style="box-shadow: 0 4px 8px 0 rgba(0, 0, 0, 0.2), 0 6px 20px 0 rgba(0, 0, 0, 0.19);
                             text-shadow:2px 2px black;">
                 <h3>
-                    Add new client group
+                    Add new resource group
                 </h3>
                 <table class="table">
@@ -407,5 +475,7 @@
                         id="inpsaver"
                         ng-disabled="newName === ''"
-                        class="btn btn-success">
+                        class="btn btn-success"
+                        style="box-shadow: 0 4px 8px 0 rgba(0, 0, 0, 0.2), 0 6px 20px 0 rgba(0, 0, 0, 0.19);
+                            text-shadow:2px 2px black;font-weight:bold;">
                     <i class="fa fa-save"></i>
                     Add {{newName}} group
@@ -413,6 +483,6 @@
             </div>
             <div class="panel-body row">
-                <h3>Choose clients </h3>
-                <h5>(This will overwrite the group set for these clients)</h5>
+                <h3>Choose resources </h3>
+                <h5>(This will overwrite the group set for these resources)</h5>
                 <table>
                     <tr ng-repeat="client in clients  | orderBy:['Name'] track by $index" class="checkbox col-md-6 col-lg-4">
@@ -440,7 +510,7 @@
                 Ungrouped
             </h2>
-            <h3>
-                All unassigned clients arrive here. Assign them to a group to remove them from this group.
-            </h3>
+            <h4>
+                All unassigned resources arrive here. Assign them to a group to remove them from this group.
+            </h4>
 
         </div>
Index: branches/WebJobManager/HeuristicLab.Clients.Hive.WebJobManager/gruntfile.js
===================================================================
--- branches/WebJobManager/HeuristicLab.Clients.Hive.WebJobManager/gruntfile.js	(revision 13782)
+++ branches/WebJobManager/HeuristicLab.Clients.Hive.WebJobManager/gruntfile.js	(revision 13795)
@@ -18,5 +18,7 @@
                         'bower_components/angular/angular.js',
                         'bower_components/angular-treeview/angular.treeview.js',
+                        'bower_components/angular-animate/angular-animate.js',
                         'bower_components/bootstrap/dist/js/bootstrap.js',
+                        'bower_components/angular-bootstrap/ui-bootstrap.js',
                         'bower_components/d3/d3.js',
                         'bower_components/moment/moment.js',
Index: branches/WebJobManager/HeuristicLab.Clients.Hive.WebJobManager/wwwroot/js/hubs/calendarhubber.js
===================================================================
--- branches/WebJobManager/HeuristicLab.Clients.Hive.WebJobManager/wwwroot/js/hubs/calendarhubber.js	(revision 13782)
+++ branches/WebJobManager/HeuristicLab.Clients.Hive.WebJobManager/wwwroot/js/hubs/calendarhubber.js	(revision 13795)
@@ -14,4 +14,5 @@
                vm.alertMessage = "No alerts";
                vm.currentcal = [];
+               $scope.permission = false;
                vm.selectedEventId = -1;
                vm.groups = [];
@@ -27,8 +28,10 @@
                        hubber.server.requestInfo();
                    });
-                   hubber.client.processData = function (data) {
+                   hubber.client.processData = function (data, users, groups) {
                        vm.data = JSON.parse(data);
+                       vm.permUsers = JSON.parse(users);
+                       vm.permGroups = JSON.parse(groups);
                        $scope.buildTree();
-
+                      
                        $scope.$apply();
                    };
@@ -48,4 +51,12 @@
                        $scope.$apply();
                    }
+                   hubber.client.processPermissions = function (id, perm) {
+                       var json = JSON.parse(perm);
+                      
+                       $scope.treeview.currentNode.permissions = json;
+                       refreshPermissions();
+                       $scope.permissionLoader = false;
+                       $scope.$apply();
+                   }
                    hubber.client.processDowntime = function (id, down) {
                        var json = JSON.parse(down);
@@ -91,13 +102,15 @@
                        $(".selected.ng-binding").addClass('loaded');
                        $scope.selectedEventId = -1;
+                       
                        if ($scope.treeview.currentNode != null && $scope.treeview.currentNode.Id != undefined) {
                            if ($scope.treeview.currentNode.calendar.length === 0) {
+                               hubber.server.requestPermissions(vm.treeview.currentNode.Id);
                                hubber.server.requestDownTime(vm.treeview.currentNode.Id);
-
+                               vm.permissionLoader = true;
                            }
                            else {
                                $timeout(function () {
+                                   refreshPermissions();
                                    $scope.currentcal = $scope.treeview.currentNode.calendar;
-
                                }, 0);
 
@@ -106,4 +119,20 @@
 
                    });
+               }
+               function refreshPermissions() {
+                   for (var i = 0; i < $scope.permUsers.length; i++){
+                       $scope.permUsers[i].state = false;
+                       for (var j = 0; j < $scope.treeview.currentNode.permissions.length; j++) {
+                           if($scope.permUsers[i].Id === $scope.treeview.currentNode.permissions[j].GrantedUserId)
+                               $scope.permUsers[i].state = true;
+                       }
+                   }
+                   for (var i = 0; i < $scope.permGroups.length; i++) {
+                       $scope.permGroups[i].state = false;
+                       for (var j = 0; j < $scope.treeview.currentNode.permissions.length; j++) {
+                           if ($scope.permGroups[i].Id === $scope.treeview.currentNode.permissions[j].GrantedUserId)
+                               $scope.permGroups[i].state = true;
+                       }
+                   }
                }
                $scope.clearTreeSelect = function () {
@@ -179,10 +208,22 @@
                    return current;
                }
-
                $scope.toggleDisposable = function () {
                    $scope.calendarDispose = true;
                    hubber.server.toggleDisposable(vm.treeview.currentNode.Id);
                }
-
+               $scope.pushPermissions = function () {
+                   var perms = [];
+                   $scope.permissionLoader = true;
+                   var node = $scope.treeview.currentNode;
+                   for (var i = 0; i < $scope.permGroups.length; i++) {
+                       if ($scope.permGroups[i].state === true)
+                           perms.push($scope.permGroups[i].Id);
+                   }
+                   for (var i = 0; i < $scope.permUsers.length; i++) {
+                       if ($scope.permUsers[i].state === true)
+                           perms.push($scope.permUsers[i].Id);
+                   }
+                   hubber.server.changePermissions(perms, node.Id);
+               }
                function collectInfoToSave(node, refresh, last) {
                    var arr = node.calendar.down[0];
@@ -273,4 +314,5 @@
                    $scope.currentcal = [];
                    hubber.server.requestDownTime(vm.treeview.currentNode.Id);
+                   $(".selected.ng-scope").removeClass('changed');
                    $(".selected.ng-binding").removeClass('changed');
 
@@ -293,5 +335,7 @@
                function clearAllCalendarsFunc() {
                    $(".ng-binding.changed").removeClass('changed');
+                   $(".ng-scope.changed").removeClass('changed');
                    $(".ng-binding.loaded").removeClass('loaded');
+                   $(".ng-scope.loaded").removeClass('loaded');
                    $scope.selectedEventId = -1;
                    $scope.treeview.currentNode.calendar = null;
@@ -301,4 +345,5 @@
                    hubber.server.requestDownTime(vm.treeview.currentNode.Id);
                    $(".selected.ng-binding").addClass('loaded');
+                   $(".selected.ng-scope").addClass('loaded');
                }
                function clearCalendarsRecurse(node) {
@@ -361,5 +406,5 @@
                    }
                    vm.treeview.currentNode.changes = true;
-                   $(".selected.ng-binding").addClass('changed');
+                   $(".selected").addClass('changed');
                }
                //*Add event by click
